
#ifndef BANGENGINE
#define BANGENGINE 

#include "CBT.hh"

#include "Mer2SequenceLocationMap.hh"
#include "HitChainer.hh"
#include "BandedAligner.hh"

class BangEngine{
 public:

  BangEngine(){
    mbTabbedOut = false;
    mbDebug = false;
    mMinScore = 0;
    mMinQuerySize = 33; // Smallest query to examine. 
  }

  bool   mbTabbedOut;
  int    mMinScore;
  int    mMinQuerySize;

  bool   mbDebug;
  bool   mbAlignments;

  SequenceVector mOptionalSource;
  String2IntMap  mSourceName2Idx;
  
  Mer2SequenceLocationMap<MerHashF,BigSequenceLocation,MerSymmetricHashF> mMerLocMap;

  MerRepeatModel<MerSymmetricHashF> mRepeatModel;

  //  Mer2IntMap mMerCounts; 

  void AddSource(string sourceName);

  void GetHits(Sequence &Query,SearchResultVec &FwdHits,SearchResultVec &RevHits);

  void Compare(Sequence &Query,vector<Chain> &FwdChains,vector<Chain> &RevChains);
  void Compare(istream &fin,ostream &fout);  

  void SetupRepeatModel(string DistFile, int maxMerCount);


  // Functions for alignment support. 
  void ReadSourceForAlignments(string SourceName);
  void WriteAlignments(ostream &fout,Sequence &Query,vector<Chain> &Chains);

};

#endif 
