#include "CBT.hh"
#include "MerRepeatModel.hh"

// An amazingly simple count mer distribution application 
// that uses Mer2IntMap to do the heavy work. 

int main(int argc, char** argv){
  
  if (argc < 3){
    cout<<"\n bangmerdist merlen thinfactor thinslice minCount outFile file1 [file2 file3 ...]"<<endl;
    exit(1);
  }

  int merlen = atoi(argv[1]);
  int thinfactor = atoi(argv[2]);
  int thinslice = atoi(argv[3]);
  int minCount = atoi(argv[4]);

  Mer::setMerSize(merlen);
  Mer::setThinFactor(thinfactor);
  Mer::setThinSlice(thinslice);

  MerRepeatModel<MerSymmetricHashF>  RM;

  // Should make this an optional choice...
  //  MerRepeatModel<MerHashF>  RM;

  for(int i = 6;i < argc;i++){
    izipstream zin;
		
    ///    if ((i% 50)==0){
    cout<<"Add "<<argv[i]<<endl;
    //}
    zin.open(argv[i]);
    RM.Add(zin);
    zin.close();
  }

  string DistOutName = argv[5];
  RM.mMinSavedCount = minCount;
  RM.mName = DistOutName;
  cout<<"Writing distribution.."<<flush;
  RM.WriteDist(DistOutName,minCount);
  cout<<"done."<<endl;
  
  // To skip over tedious freeing of output.  
  exit(1);
}
